'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hocIntersectionObserverWithOptions = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shouldLoadIntersectionObserver = function shouldLoadIntersectionObserver() {
  return !('IntersectionObserver' in window) || !('IntersectionObserverEntry' in window) || !('intersectionRatio' in window.IntersectionObserverEntry.prototype);
}; /* global IntersectionObserver */
var hocIntersectionObserverWithOptions = exports.hocIntersectionObserverWithOptions = function hocIntersectionObserverWithOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (BaseComponent) {
    var _class, _temp2;

    var displayName = BaseComponent.displayName;

    return _temp2 = _class = function (_Component) {
      (0, _inherits3.default)(WithIntersectionObserver, _Component);

      function WithIntersectionObserver() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, WithIntersectionObserver);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = WithIntersectionObserver.__proto__ || (0, _getPrototypeOf2.default)(WithIntersectionObserver)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
          isIntersecting: true
        }, _this.handleChange = function (_ref2) {
          var _ref3 = (0, _slicedToArray3.default)(_ref2, 1),
              isIntersecting = _ref3[0].isIntersecting;

          _this.setState({ isIntersecting: isIntersecting });
        }, _this.innerRef = function (elem) {
          _this.refTarget = elem;
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(WithIntersectionObserver, [{
        key: 'componentDidMount',
        value: function () {
          var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            var target;
            return _regenerator2.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    target = this.refTarget;

                    if (!shouldLoadIntersectionObserver()) {
                      _context.next = 4;
                      break;
                    }

                    _context.next = 4;
                    return import( /* webpackChunkName: "intersection-observer" */'intersection-observer');

                  case 4:
                    new IntersectionObserver(this.handleChange).observe(target, options);

                  case 5:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function componentDidMount() {
            return _ref4.apply(this, arguments);
          }

          return componentDidMount;
        }()
      }, {
        key: 'render',
        value: function render() {
          var isVisible = this.state.isIntersecting;

          return _react2.default.createElement(BaseComponent, (0, _extends3.default)({}, this.props, {
            isVisible: isVisible,
            innerRef: this.innerRef
          }));
        }
      }]);
      return WithIntersectionObserver;
    }(_react.Component), _class.displayName = 'withIntersectionObserver(' + displayName + ')', _class.contextTypes = BaseComponent.contextTypes, _temp2;
  };
};

exports.default = hocIntersectionObserverWithOptions();